
#ifndef OPTFLOW_H
#define OPTFLOW_H

//#define FUNC_DBG

typedef unsigned char pix_t;
typedef unsigned short yuv_t;

#define LB_WIDTH 1920

#define KMED 53
#define KMEDP1 (KMED+1)

#ifdef __cplusplus
extern "C" {
#endif

int fpga_optflow (yuv_t *frame0, yuv_t *frame1, yuv_t *framef,
		int height, int width, int stride, float clip_flowmag);

#ifdef __cplusplus
}
#endif

#pragma SDS data access_pattern(matB:SEQUENTIAL, pixStream:SEQUENTIAL)
#pragma SDS data mem_attribute(matB:PHYSICAL_CONTIGUOUS|NON_CACHEABLE)
#pragma SDS data copy(matB[0:stride*height])
void readMatRows (yuv_t *matB, pix_t* pixStream,
		int height, int width, int stride);

#pragma SDS data access_pattern(pixStream:SEQUENTIAL, dst:SEQUENTIAL)
#pragma SDS data mem_attribute(dst:PHYSICAL_CONTIGUOUS|NON_CACHEABLE)
#pragma SDS data copy(dst[0:stride*height])
void writeMatRows (yuv_t* pixStream, yuv_t *dst,
		int height, int width, int stride);

#pragma SDS data access_pattern(f0Stream:SEQUENTIAL, f1Stream:SEQUENTIAL)
#pragma SDS data access_pattern(ixix_out:SEQUENTIAL, ixiy_out:SEQUENTIAL, iyiy_out:SEQUENTIAL)
#pragma SDS data access_pattern(dix_out:SEQUENTIAL, diy_out:SEQUENTIAL)
void computeSum(pix_t* f0Stream, pix_t* f1Stream,
		int* ixix_out, int* ixiy_out, int* iyiy_out,
		int*  dix_out, int* diy_out,
		int height, int width);

#pragma SDS data access_pattern(ixix:SEQUENTIAL, ixiy:SEQUENTIAL, iyiy:SEQUENTIAL)
#pragma SDS data access_pattern(dix:SEQUENTIAL, diy:SEQUENTIAL)
#pragma SDS data access_pattern(fx_out:SEQUENTIAL, fy_out:SEQUENTIAL)
void computeFlow(int* ixix, int* ixiy, int* iyiy,
		int* dix, int* diy,
		float* fx_out, float* fy_out,
		int height, int width);

#pragma SDS data access_pattern(fx:SEQUENTIAL, fy:SEQUENTIAL, out_pix:SEQUENTIAL)
void getOutPix (float* fx, float* fy, yuv_t* out_pix,
		int height, int width, float clip_flowmag);


#endif

